{$DEFINE DECAL}
unit Main;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, ExtCtrls, RectUtils, Layouts;

type
	{$IFDEF DECAL}
	TDemoPane = class(TLTPane)
	public
		procedure Paint(Canvas: TCanvas); override;
	end;
	{$ENDIF}

	TfmMain = class(TForm)
		PaintBox1: TPaintBox;
		procedure FormCreate(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure PaintBox1Paint(Sender: TObject);
	private
		{ Private declarations }
	public
		FLayout: TLayout;
		{ Public declarations }
	end;

var
	fmMain: TfmMain;

implementation

{$R *.dfm}

procedure TfmMain.FormCreate(Sender: TObject);
var RootNode, CntrNode, CntrNode1, CntrNode2: TLTCntrNode;
    Pane: TLTPane;
begin
	DoubleBuffered := true;
	{$IFDEF DECAL}
	FLayout := TLayout.Create(nil);

	RootNode := TLTCntrNode.Create(1,2);

	CntrNode := RootNode.CreateCntrNode(0, 0, 2, 1);
	  Pane := TDemoPane.Create(Self);
    Pane.Name := 'Pane1';
    CntrNode.CreatePaneNode(0,0, Pane, Size(100,0));
		  CntrNode1 := CntrNode.CreateCntrNode(1, 0, 1, 2);
     	  Pane := TDemoPane.Create(Self);
        Pane.Name := 'Pane2';
	  		CntrNode1.CreatePaneNode(0,0, Pane, Size(0, 20));
         	Pane := TDemoPane.Create(Self);
          Pane.Name := 'Pane3';
      	  CntrNode1.CreatePaneNode(0,1, Pane);

 	Pane := TDemoPane.Create(Self);
  Pane.Name := 'Pane4';
	RootNode.CreatePaneNode(0,1, Pane, Size(0,100));

	FLayout.Root := RootNode;
	{$ENDIF}
end;

{$IFDEF DECAL}
{ TDemoPane }

procedure TDemoPane.Paint(Canvas: TCanvas);
var PaintRect: TRect;
		TextRect: TRect;
		TextSize: TSize;
		Txt: string;
begin
	PaintRect := PaintArea;

	Canvas.Brush.Color := clWindow;
	Canvas.Pen.Color := clBlack;

	Canvas.FillRect(PaintRect);

	InflateRect(PaintRect,-1,-1);
	Canvas.Rectangle(PaintRect);

	Txt := Name;
  if Txt = 'Pane3' then
    Txt := 'Move mouse within the test form';

	TextSize := Canvas.TextExtent(Txt);
	TextRect := RectWithSize(TextSize);
	Center(TextRect, PaintArea);

	Canvas.TextOut(TextRect.Left, TextRect.Top, Txt);
end;
{$ENDIF}

procedure TfmMain.FormDestroy(Sender: TObject);
begin
	{$IFDEF DECAL}
	FreeAndNil(FLayout);
	{$ENDIF}
end;

procedure TfmMain.PaintBox1Paint(Sender: TObject);
{$IFDEF DECAL}
var PaintBox: TPaintBox;
{$ENDIF}
begin
	{$IFDEF DECAL}
	PaintBox := Sender as TPaintBox;

	FLayout.BoundsRect := PaintBox.BoundsRect;
	FLayout.Realign;

	FLayout.Paint(PaintBox.Canvas);
	{$ENDIF}
end;

end.
